import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Monster here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Monster extends BadGuys
{
    int frame = 0;
    private int animationCount;
    private int vSpeed = 0;
    private int acceleration = 2;

    private int spriteHeight = getImage().getHeight();
    private int spriteWidth = getImage().getWidth();
    private int lookForGroundDistance = (int)spriteHeight/2;
    private int lookForEdge = (int)spriteWidth/2;
    
    private int speed = 1;

    GreenfootImage monster1l = new GreenfootImage("creeper1l.png");
    GreenfootImage monster2l = new GreenfootImage("creeper2l.png");
    GreenfootImage monster3l = new GreenfootImage("creeper3l.png");

    GreenfootImage monster1r = new GreenfootImage("creeper1r.png");
    GreenfootImage monster2r = new GreenfootImage("creeper2r.png");
    GreenfootImage monster3r = new GreenfootImage("creeper3r.png");

    /**
     * Act - do whatever the Monster wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkFall();
        checkEdge();
        move();
        animationCount ++;
        tryToEatPlayer();
        if (speed <0)
        {
            if (animationCount % 4 == 0) //Slows down animation
            animateLeft();
        }
        else
        {
            if (animationCount % 4 == 0)
            animateRight();
        }
    } 

    public void move()
    {
        Actor ground = getOneObjectAtOffset(lookForEdge, lookForGroundDistance, Platform.class);
        if (ground == null)
        {
            speed *= -1; //Reverses direction
            lookForEdge *= -1; //Looks for a negative number
        }
        else
        {
            move(speed);
        }
    }
    
    public void tryToEatPlayer()
    {
        if (canSee(Player.class))
        {
            eat(Player.class);
            Greenfoot.stop();
            ((MyWorld)getWorld()).endGame();
        }
    }

    public void fall()
    {
        setLocation(getX(), getY() + vSpeed);
        if (vSpeed <=9)
        {
            vSpeed = vSpeed + acceleration;
        }
    }

    public boolean onGround()
    {
        int spriteHeight = getImage().getHeight();
        int yDistance = (int)(spriteHeight/2) + 5;
        Actor ground = getOneObjectAtOffset(0, getImage().getHeight()/2, Platform.class);
        if (ground == null)
        {
            return false;
        }
        else
        {
            moveToGround(ground);
            return true;
        }
    }

    public void moveToGround (Actor ground)
    {
        int groundHeight = ground.getImage().getHeight();
        int newY = ground.getY() - (groundHeight + getImage().getHeight())/2;
        setLocation(getX(), newY);
    }

    public void checkFall()
    {
        if (onGround())
        {
            vSpeed = 0;
        }
        else
        {
            fall();
        }
    }
    
    public void checkEdge()
    {
        if (getX() < 10 || getX() > getWorld().getWidth() - 10)
        {
            speed *= -1;
        }
    }

    public void animateLeft()
    {
        if(frame == 0)
        {
            setImage(monster1l);
        }
        if(frame == 1)
        {
            setImage(monster2l);
        }
        if(frame == 2)
        {
            setImage(monster3l);
            frame = 0;
        }
        frame++;
    }

    public void animateRight()
    {
        if(frame == 0)
        {
            setImage(monster1r);
        }
        if(frame == 1)
        {
            setImage(monster2r);
        }
        if(frame == 2)
        {
            setImage(monster3r);
            frame = 0;
        }
        frame++;
    }
}    
