import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Actor
{
    private int vSpeed = 0;
    private int acceleration = 1;
    private boolean jumping;
    private int jumpStrength = 16;
    private int speed = 4;
    private boolean hasnugget;
    
    private int direction = 1; // 1 = right; -1 = left
    private int shootingCounter = 20; //Delay shooting

    private GreenfootImage player1r = new GreenfootImage("player1r.png");
    private GreenfootImage player2r = new GreenfootImage("player2r.png");
    private GreenfootImage player3r = new GreenfootImage("player3r.png");
    private GreenfootImage player4r = new GreenfootImage("player4r.png");
    private GreenfootImage player5r = new GreenfootImage("player5r.png");
    private GreenfootImage player6r = new GreenfootImage("player6r.png");
    private GreenfootImage player1l = new GreenfootImage("player1l.png");
    private GreenfootImage player2l = new GreenfootImage("player2l.png");
    private GreenfootImage player3l = new GreenfootImage("player3l.png");
    private GreenfootImage player4l = new GreenfootImage("player4l.png");
    private GreenfootImage player5l = new GreenfootImage("player5l.png");
    private GreenfootImage player6l = new GreenfootImage("player6l.png");
    private int frame = 1;
    private int animationCounter = 0;

    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkFall();
        checkKey();
        platformAbove();
        checkRightWall();
        checkLeftWall();
        shooting();
        shootingCounter --;
        animationCounter++;
        grab();
        exit();
        tryToEatDoor();
    }

    public void checkKey()
    {
        if (Greenfoot.isKeyDown("up") && jumping == false)
        {
            jump();
        }
        if (Greenfoot.isKeyDown("right"))
        {
            direction = 1;
            moveRight();
        }
        if (Greenfoot.isKeyDown("left"))
        {
            direction = -1;
            moveLeft();
        }
    }
    
    public boolean shooting()
    {
        if (Greenfoot.isKeyDown("space") && shootingCounter <= 0 && direction == 1)
        {
            getWorld().addObject(new ShootRight(), getX(), getY());
            shootingCounter = 20;
            return true;
        }
        if (Greenfoot.isKeyDown("space") && shootingCounter <= 0 && direction == -1)
        {
            getWorld().addObject(new ShootLeft(), getX(), getY());
            shootingCounter = 20;
            return true;
        }
        return false;
    }

    public void moveRight()
    {
        setLocation(getX() + speed, getY());
        if (animationCounter % 4 == 0)
        {
            animateRight();
        }
    }

    public void animateRight()
    {
        if (frame == 1)
        {
            setImage(player1r);
        }
        else if (frame == 2)
        {
            setImage(player2r);
        }
        else if (frame == 3)
        {
            setImage(player3r);
        }
        else if (frame == 4)
        {
            setImage(player4r);
        }
        else if (frame == 5)
        {
            setImage(player5r);
        }
        else if (frame == 6)
        {
            setImage(player6r);
            frame = 1;
            return;
        }
        frame++;
    }

    public void moveLeft()
    {
        setLocation(getX() - speed, getY());
        if (animationCounter % 4 == 0)
        {
            animateLeft();
        }
    }

    public void animateLeft()
    {
        if (frame == 1)
        {
            setImage(player1l);
        }
        else if (frame == 2)
        {
            setImage(player2l);
        }
        else if (frame == 3)
        {
            setImage(player3l);
        }
        else if (frame == 4)
        {
            setImage(player4l);
        }
         else if (frame == 5)
        {
            setImage(player5l);
        }
        else if (frame == 6)
        {
            setImage(player6l);
            frame = 1;
            return;
        }
        frame++;
    }
    
    public boolean platformAbove()
    {
        int spriteHeight = getImage().getHeight();
        int yDistance = (int)(spriteHeight/-2);
        Actor ceiling = getOneObjectAtOffset(0, yDistance, Platform.class);
        if (ceiling != null)
        {
            vSpeed = 1;
            bopHead(ceiling);
            return true;
        }
        else
        {
            return false;
        }
    }
    
    public boolean checkRightWall()
    {
        int spriteWidth = getImage().getWidth();
        int xDistance = (int)(spriteWidth/2);
        Actor rightWall = getOneObjectAtOffset(xDistance, 0, Platform.class);
        if (rightWall == null)
        {
            return false;
        }
        else 
        {
            stopByRightWall(rightWall);
            return true;
        }
    }
    
    public void stopByRightWall(Actor rightWall)
    {
        int wallWidth = rightWall.getImage().getWidth();
        int newX = rightWall.getX() - (wallWidth + getImage().getWidth())/2;
        setLocation(newX - 5, getY());
    }
    
     public boolean checkLeftWall()
    {
        int spriteWidth = getImage().getWidth();
        int xDistance = (int)(spriteWidth/-2);
        Actor leftWall = getOneObjectAtOffset(xDistance, 0, Platform.class);
        if (leftWall == null)
        {
            return false;
        }
        else 
        {
            stopByLeftWall(leftWall);
            return true;
        }
    }
    
    public void stopByLeftWall(Actor leftWall)
    {
        int wallWidth = leftWall.getImage().getWidth();
        int newX = leftWall.getX() + (wallWidth + getImage().getWidth())/2;
        setLocation(newX + 5, getY());
    }
    
     public void bopHead(Actor ceiling)
    {
        int ceilingHeight = ceiling.getImage().getHeight();
        int newY = ceiling.getY() + (ceilingHeight + getImage().getHeight())/2;
        setLocation(getX(), newY);
    }

    public void fall()
    {
        setLocation(getX(), getY() + vSpeed);
        jumping = true;
        if (vSpeed <=9)
        {
            vSpeed = vSpeed + acceleration;
        }
    }

    public boolean onGround()
    {
        int spriteHeight = getImage().getHeight();
        int yDistance = (int)(spriteHeight/2) + 5;
        Actor ground = getOneObjectAtOffset(0, getImage().getHeight()/2, Platform.class);
        if (ground == null)
        {
            jumping = true;
            return false;
        }
        else
        {
            moveToGround(ground);
            return true;
        }
    }
    
    public void moveToGround (Actor ground)
    {
        int groundHeight = ground.getImage().getHeight();
        int newY = ground.getY() - (groundHeight + getImage().getHeight())/2;
        setLocation(getX(), newY);
        jumping = false;
    }

    public void checkFall()
    {
        if (onGround())
        {
            vSpeed = 0;
        }
        else
        {
            fall();
        }
    }

    public void jump()
    {
        vSpeed = vSpeed - jumpStrength;
        jumping = true;
        fall();
    }
    
    public void grab()
    {
        if (canSee(GoldNugget.class))
        {
            get(GoldNugget.class);
            hasnugget = true;
        }
    }
    
    public void exit()
    {
        if (canSee(Door.class) && hasnugget == true)
        {
           hasnugget = false;
        }
    }
    
    public void tryToEatDoor()
    {
        if (canSee(Door.class))
        {
            Greenfoot.stop();
            ((MyWorld)getWorld()).winGame();
        }
    }
    
       /**
     * Return true if we can see an object of class 'clss' right where we are.
     * False if there is no such object here.
     */
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;
    }
    
    /**
     * Try to grab an object of class 'clss'. This is only successful if there
     * is such an object where we currently are. Otherwise this method does nothing.
     */
    public void get(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if (actor != null)
        {
            getWorld().removeObject(actor);
        }
    }
}
